diff -r 6b3ac7e864ba source/maths/scripting/JSInterface_Vector3D.cpp
--- a/source/maths/scripting/JSInterface_Vector3D.cpp	Wed Nov 03 17:52:07 2010 +0000
+++ b/source/maths/scripting/JSInterface_Vector3D.cpp	Thu Nov 04 14:52:01 2010 +0000
@@ -21,11 +21,6 @@
 #include "scripting/JSConversions.h"
 #include "scripting/ScriptingHost.h"
 
-namespace JSI_Vector3D
-{
-	static CVector3D* GetVector( JSContext* cx, JSObject* obj );
-}
-
 JSClass JSI_Vector3D::JSI_class = {
 	"Vector3D", JSCLASS_HAS_PRIVATE,
 	JS_PropertyStub, JS_PropertyStub,
@@ -45,24 +40,13 @@
 
 JSFunctionSpec JSI_Vector3D::JSI_methods[] = 
 {
-	{ "toString", JSI_Vector3D::toString, 0, 0, 0 },
-	{ "add", JSI_Vector3D::add, 1, 0, 0 },
-	{ "subtract", JSI_Vector3D::subtract, 1, 0, 0 },
-	{ "minus", JSI_Vector3D::subtract, 1, 0, 0 },
-	{ "negate", JSI_Vector3D::negate, 1, 0, 0 },
-	{ "scale", JSI_Vector3D::scale, 1, 0, 0 },
-	{ "multiply", JSI_Vector3D::scale, 1, 0, 0 },
-	{ "divide", JSI_Vector3D::divide, 1, 0, 0 },
-	{ "dot", JSI_Vector3D::dot, 1, 0, 0 },
-	{ "cross", JSI_Vector3D::cross, 1, 0, 0 },
-	{ "length", JSI_Vector3D::length, 0, 0, 0 },
-	{ "normalize", JSI_Vector3D::normalize, 0, 0, 0 },
+	{ "toString", JSI_Vector3D::toString, 0, 0 },
 	{ 0 }
 };
 
 void JSI_Vector3D::init()
 {
-	g_ScriptingHost.DefineCustomObjectType( &JSI_class, JSI_Vector3D::construct, 0, JSI_props, JSI_methods, NULL, NULL );
+	g_ScriptingHost.DefineCustomObjectType(&JSI_class, JSI_Vector3D::construct, 0, JSI_props, JSI_methods, NULL, NULL);
 }
 
 JSI_Vector3D::Vector3D_Info::Vector3D_Info()
@@ -71,19 +55,19 @@
 	vector = new CVector3D();
 }
 
-JSI_Vector3D::Vector3D_Info::Vector3D_Info( float x, float y, float z )
+JSI_Vector3D::Vector3D_Info::Vector3D_Info(float x, float y, float z)
 {
 	owner = NULL;
-	vector = new CVector3D( x, y, z );
+	vector = new CVector3D(x, y, z);
 }
 
-JSI_Vector3D::Vector3D_Info::Vector3D_Info( const CVector3D& copy )
+JSI_Vector3D::Vector3D_Info::Vector3D_Info(const CVector3D& copy)
 {
 	owner = NULL;
-	vector = new CVector3D( copy.X, copy.Y, copy.Z );
+	vector = new CVector3D(copy.X, copy.Y, copy.Z);
 }
 
-JSI_Vector3D::Vector3D_Info::Vector3D_Info( CVector3D* attach, IPropertyOwner* _owner )
+JSI_Vector3D::Vector3D_Info::Vector3D_Info(CVector3D* attach, IPropertyOwner* _owner)
 {
 	owner = _owner;
 	updateFn = NULL;
@@ -91,7 +75,7 @@
 	vector = attach;
 }
 
-JSI_Vector3D::Vector3D_Info::Vector3D_Info( CVector3D* attach, IPropertyOwner* _owner, void( IPropertyOwner::*_updateFn )(void) )
+JSI_Vector3D::Vector3D_Info::Vector3D_Info(CVector3D* attach, IPropertyOwner* _owner, void(IPropertyOwner::*_updateFn)(void))
 {
 	owner = _owner;
 	updateFn = _updateFn;
@@ -99,7 +83,8 @@
 	vector = attach;
 }
 
-JSI_Vector3D::Vector3D_Info::Vector3D_Info( CVector3D* attach, IPropertyOwner* _owner, void( IPropertyOwner::*_updateFn )(void), void( IPropertyOwner::*_freshenFn )(void) )
+JSI_Vector3D::Vector3D_Info::Vector3D_Info(CVector3D* attach, IPropertyOwner* _owner, void(IPropertyOwner::*_updateFn)(void),
+		void(IPropertyOwner::*_freshenFn)(void))
 {
 	owner = _owner;
 	updateFn = _updateFn;
@@ -109,245 +94,116 @@
 
 JSI_Vector3D::Vector3D_Info::~Vector3D_Info()
 {
-	if( !owner ) delete( vector );
+	if (!owner)
+		delete (vector);
 }
 
-JSBool JSI_Vector3D::getProperty( JSContext* cx, JSObject* obj, jsval id, jsval* vp )
+JSBool JSI_Vector3D::getProperty(JSContext* cx, JSObject* obj, jsid id, jsval* vp)
 {
-	if( !JSVAL_IS_INT( id ) )
-		return( JS_TRUE );
+	if (!JSID_IS_INT(id))
+		return JS_TRUE;
 
-	Vector3D_Info* vectorInfo = (Vector3D_Info*)JS_GetPrivate( cx, obj );
-	if( !vectorInfo )
+	Vector3D_Info* vectorInfo = (Vector3D_Info*)JS_GetInstancePrivate(cx, obj, &JSI_Vector3D::JSI_class, NULL);
+	if (!vectorInfo)
+		return JS_FALSE;
+
+	CVector3D* vectorData = vectorInfo->vector;
+
+	if (vectorInfo->owner && vectorInfo->freshenFn)
+		((vectorInfo->owner)->*(vectorInfo->freshenFn))();
+
+	switch (JSID_TO_INT(id))
 	{
-		JS_ReportError( cx, "[Vector3D] Invalid reference" );
-		return( JS_TRUE );
+	case component_x:
+		return JS_NewNumberValue(cx, vectorData->X, vp);
+	case component_y:
+		return JS_NewNumberValue(cx, vectorData->Y, vp);
+	case component_z:
+		return JS_NewNumberValue(cx, vectorData->Z, vp);
 	}
 
- 	CVector3D* vectorData = vectorInfo->vector;
+	return JS_FALSE;
+}
 
-	if( vectorInfo->owner && vectorInfo->freshenFn ) ( (vectorInfo->owner)->*(vectorInfo->freshenFn) )();
-	
-	switch( ToPrimitive<int>( id ) )
+JSBool JSI_Vector3D::setProperty(JSContext* cx, JSObject* obj, jsid id, jsval* vp)
+{
+	if (!JSID_IS_INT(id))
+		return JS_TRUE;
+
+	Vector3D_Info* vectorInfo = (Vector3D_Info*)JS_GetInstancePrivate(cx, obj, &JSI_Vector3D::JSI_class, NULL);
+	if (!vectorInfo)
+		return JS_FALSE;
+
+	CVector3D* vectorData = vectorInfo->vector;
+
+	if (vectorInfo->owner && vectorInfo->freshenFn)
+		((vectorInfo->owner)->*(vectorInfo->freshenFn))();
+
+	switch (JSID_TO_INT(id))
 	{
-	case component_x: *vp = DOUBLE_TO_JSVAL( JS_NewDouble( cx, vectorData->X ) ); return( JS_TRUE );
-	case component_y: *vp = DOUBLE_TO_JSVAL( JS_NewDouble( cx, vectorData->Y ) ); return( JS_TRUE );
-	case component_z: *vp = DOUBLE_TO_JSVAL( JS_NewDouble( cx, vectorData->Z ) ); return( JS_TRUE );
+	case component_x:
+		vectorData->X = ToPrimitive<float> (*vp);
+		break;
+	case component_y:
+		vectorData->Y = ToPrimitive<float> (*vp);
+		break;
+	case component_z:
+		vectorData->Z = ToPrimitive<float> (*vp);
+		break;
 	}
 
-	return( JS_FALSE );
+	if (vectorInfo->owner && vectorInfo->updateFn)
+		((vectorInfo->owner)->*(vectorInfo->updateFn))();
+
+	return JS_TRUE;
 }
 
-JSBool JSI_Vector3D::setProperty( JSContext* cx, JSObject* obj, jsval id, jsval* vp )
+JSBool JSI_Vector3D::construct(JSContext* cx, uintN argc, jsval* vp)
 {
-	if( !JSVAL_IS_INT( id ) )
-		return( JS_TRUE );
+	JSObject* vector = JS_NewObject(cx, &JSI_Vector3D::JSI_class, NULL, NULL);
 
-	Vector3D_Info* vectorInfo = (Vector3D_Info*)JS_GetPrivate( cx, obj );
-	if( !vectorInfo )
+	if (argc == 0)
 	{
-		JS_ReportError( cx, "[Vector3D] Invalid reference" );
-		return( JS_TRUE );
-	}
-	CVector3D* vectorData = vectorInfo->vector;
-
-	if( vectorInfo->owner && vectorInfo->freshenFn ) ( (vectorInfo->owner)->*(vectorInfo->freshenFn) )();
-
-	switch( ToPrimitive<int>( id ) )
-	{
-	case component_x: vectorData->X = ToPrimitive<float>( *vp ); break;
-	case component_y: vectorData->Y = ToPrimitive<float>( *vp ); break;
-	case component_z: vectorData->Z = ToPrimitive<float>( *vp ); break;
-	}
-
-	
-	if( vectorInfo->owner && vectorInfo->updateFn ) ( (vectorInfo->owner)->*(vectorInfo->updateFn) )();
-
-	return( JS_TRUE );
-}
-
-JSBool JSI_Vector3D::construct( JSContext* cx, JSObject* UNUSED(obj), uintN argc, jsval* argv, jsval* rval )
-{
-	JSObject* vector = JS_NewObject( cx, &JSI_Vector3D::JSI_class, NULL, NULL );
-	
-	if( argc == 0 )
-	{
-		JS_SetPrivate( cx, vector, new Vector3D_Info() );
-		*rval = OBJECT_TO_JSVAL( vector );
-		return( JS_TRUE );
+		JS_SetPrivate(cx, vector, new Vector3D_Info());
+		JS_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(vector));
+		return JS_TRUE;
 	}
 
 	JSU_REQUIRE_PARAMS(3);
 	try
 	{
-		float x = ToPrimitive<float>( argv[0] );
-		float y = ToPrimitive<float>( argv[1] );
-		float z = ToPrimitive<float>( argv[2] );
-		JS_SetPrivate( cx, vector, new Vector3D_Info( x, y, z ) );
-		*rval = OBJECT_TO_JSVAL( vector );
-		return( JS_TRUE );
+		float x = ToPrimitive<float> (JS_ARGV(cx, vp)[0]);
+		float y = ToPrimitive<float> (JS_ARGV(cx, vp)[1]);
+		float z = ToPrimitive<float> (JS_ARGV(cx, vp)[2]);
+		JS_SetPrivate(cx, vector, new Vector3D_Info(x, y, z));
+		JS_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(vector));
+		return JS_TRUE;
 	}
 	catch (PSERROR_Scripting_ConversionFailed)
 	{
 		// Invalid input (i.e. can't be coerced into doubles) - fail
-		JS_ReportError( cx, "Invalid parameters to Vector3D constructor" );
-		*rval = JSVAL_NULL;
-		return( JS_FALSE );
+		JS_ReportError(cx, "Invalid parameters to Vector3D constructor");
+		return JS_FALSE;
 	}
 }
 
-void JSI_Vector3D::finalize( JSContext* cx, JSObject* obj )
+void JSI_Vector3D::finalize(JSContext* cx, JSObject* obj)
 {
-	delete( (Vector3D_Info*)JS_GetPrivate( cx, obj ) );
+	delete ((Vector3D_Info*)JS_GetPrivate(cx, obj));
 }
 
-JSBool JSI_Vector3D::toString( JSContext* cx, JSObject* obj,
-	uintN UNUSED(argc), jsval* UNUSED(argv), jsval* rval )
+JSBool JSI_Vector3D::toString(JSContext* cx, uintN argc, jsval* vp)
 {
 	char buffer[256];
-	Vector3D_Info* vectorInfo = (Vector3D_Info*)JS_GetPrivate( cx, obj );
+	Vector3D_Info* vectorInfo = (Vector3D_Info*)JS_GetInstancePrivate(cx, JS_THIS_OBJECT(cx, vp), &JSI_Vector3D::JSI_class, NULL);
+	if (!vectorInfo)
+		return JS_FALSE;
 
-	if( !vectorInfo ) return( JS_TRUE );
+	if (vectorInfo->owner && vectorInfo->freshenFn)
+		((vectorInfo->owner)->*(vectorInfo->freshenFn))();
 
-	if( vectorInfo->owner && vectorInfo->freshenFn ) ( (vectorInfo->owner)->*(vectorInfo->freshenFn) )();
-
- 	CVector3D* vectorData = vectorInfo->vector;
-	sprintf_s( buffer, ARRAY_SIZE(buffer), "[object Vector3D: ( %f, %f, %f )]", vectorData->X, vectorData->Y, vectorData->Z );
-	*rval = STRING_TO_JSVAL( JS_NewStringCopyZ( cx, buffer ) );
-	return( JS_TRUE );
+	CVector3D* vectorData = vectorInfo->vector;
+	sprintf_s(buffer, ARRAY_SIZE(buffer), "[object Vector3D: ( %f, %f, %f )]", vectorData->X, vectorData->Y, vectorData->Z);
+	JS_SET_RVAL(cx, vp, STRING_TO_JSVAL(JS_NewStringCopyZ(cx, buffer)));
+	return JS_TRUE;
 }
-
-CVector3D* JSI_Vector3D::GetVector( JSContext* cx, JSObject* obj )
-{
-	Vector3D_Info* vectorInfo = (Vector3D_Info*)JS_GetInstancePrivate( cx, obj, &JSI_class, NULL );
-	if( !vectorInfo )
-	{
-		JS_ReportError( cx, "[Vector3D] Invalid reference" );
-		return( NULL );
-	}
-	if( vectorInfo->owner && vectorInfo->freshenFn ) ( (vectorInfo->owner)->*(vectorInfo->freshenFn) )();
-	return( vectorInfo->vector );
-}
-
-#define GET_VECTORS\
-	CVector3D* a = GetVector( cx, obj );\
-	if(!a)\
-		return( JS_TRUE );\
-	if( ( argc == 0 ) || !JSVAL_IS_OBJECT( argv[0] ) )\
-	{\
-invalid_param:\
-		JS_ReportError( cx, "[Vector3D] Invalid parameter" );\
-		return( JS_TRUE );\
-	}\
-	CVector3D* b = GetVector( cx, JSVAL_TO_OBJECT( argv[0] ) );\
-	if(!b)\
-		goto invalid_param;
-
-#define GET_VECTOR_AND_FLOAT\
-	CVector3D* v = GetVector( cx, obj );\
-	if(!v)\
-		return( JS_TRUE );\
-	float f;\
-	if( ( argc == 0 ) || !ToPrimitive( cx, argv[0], f ) )\
-	{\
-		JS_ReportError( cx, "Invalid parameter" );\
-		return( JS_TRUE );\
-	}
-
-
-JSBool JSI_Vector3D::add( JSContext* cx, JSObject* obj, uintN argc, jsval* argv, jsval* rval )
-{
-	GET_VECTORS;
-
-	JSObject* vector3d = JS_NewObject( g_ScriptingHost.getContext(), &JSI_Vector3D::JSI_class, NULL, NULL );
-	JS_SetPrivate( g_ScriptingHost.getContext(), vector3d, new JSI_Vector3D::Vector3D_Info( *a + *b ) );
-	*rval = OBJECT_TO_JSVAL( vector3d );
-
-	return( JS_TRUE );
-}
-
-JSBool JSI_Vector3D::subtract( JSContext* cx, JSObject* obj, uintN argc, jsval* argv, jsval* rval )
-{
-	GET_VECTORS;
-
-	JSObject* vector3d = JS_NewObject( g_ScriptingHost.getContext(), &JSI_Vector3D::JSI_class, NULL, NULL );
-	JS_SetPrivate( g_ScriptingHost.getContext(), vector3d, new JSI_Vector3D::Vector3D_Info( *a - *b ) );
-	*rval = OBJECT_TO_JSVAL( vector3d );
-
-	return( JS_TRUE );
-}
-
-JSBool JSI_Vector3D::negate( JSContext* cx, JSObject* obj,
-	uintN UNUSED(argc), jsval* UNUSED(argv), jsval* rval )
-{
-	CVector3D* v = GetVector( cx, obj );
-	if(!v)
-		return( JS_TRUE );
-
-	*rval = ToJSVal( -( *v ) );
-
-	return( JS_TRUE );
-}
-
-JSBool JSI_Vector3D::scale( JSContext* cx, JSObject* obj, uintN argc, jsval* argv, jsval* rval )
-{
-	GET_VECTOR_AND_FLOAT;
-
-	JSObject* vector3d = JS_NewObject( g_ScriptingHost.getContext(), &JSI_Vector3D::JSI_class, NULL, NULL );
-	JS_SetPrivate( g_ScriptingHost.getContext(), vector3d, new JSI_Vector3D::Vector3D_Info( *v * f ) );
-	*rval = OBJECT_TO_JSVAL( vector3d );
-
-	return( JS_TRUE );
-}
-
-JSBool JSI_Vector3D::divide( JSContext* cx, JSObject* obj, uintN argc, jsval* argv, jsval* rval )
-{
-	GET_VECTOR_AND_FLOAT;
-
-	JSObject* vector3d = JS_NewObject( g_ScriptingHost.getContext(), &JSI_Vector3D::JSI_class, NULL, NULL );
-	JS_SetPrivate( g_ScriptingHost.getContext(), vector3d, new JSI_Vector3D::Vector3D_Info( *v * ( 1.0f / f ) ) );
-	*rval = OBJECT_TO_JSVAL( vector3d );
-
-	return( JS_TRUE );
-}
-
-JSBool JSI_Vector3D::dot( JSContext* cx, JSObject* obj, uintN argc, jsval* argv, jsval* rval )
-{
-	GET_VECTORS;
-
-	*rval = ToJSVal( a->Dot( *b ) );
-	return( JS_TRUE );
-}
-
-JSBool JSI_Vector3D::cross( JSContext* cx, JSObject* obj, uintN argc, jsval* argv, jsval* rval )
-{
-	GET_VECTORS;
-
-	*rval = ToJSVal( a->Cross( *b ) );
-	return( JS_TRUE );
-}
-
-JSBool JSI_Vector3D::length( JSContext* cx, JSObject* obj,
-	uintN UNUSED(argc), jsval* UNUSED(argv), jsval* rval )
-{
-	CVector3D* v = GetVector( cx, obj );
-	if(!v)
-		return( JS_TRUE );
-
-	*rval = ToJSVal( v->Length() );
-	return( JS_TRUE );
-}
-
-JSBool JSI_Vector3D::normalize( JSContext* cx, JSObject* obj,
-	uintN UNUSED(argc), jsval* UNUSED(argv), jsval* rval )
-{
-	CVector3D* v = GetVector( cx, obj );
-	if(!v)
-		return( JS_TRUE );
-
-	CVector3D r( v->X, v->Y, v->Z );
-	r.Normalize();
-
-	*rval = ToJSVal( r );
-	return( JS_TRUE );
-}
diff -r 6b3ac7e864ba source/maths/scripting/JSInterface_Vector3D.h
--- a/source/maths/scripting/JSInterface_Vector3D.h	Wed Nov 03 17:52:07 2010 +0000
+++ b/source/maths/scripting/JSInterface_Vector3D.h	Thu Nov 04 14:52:01 2010 +0000
@@ -36,42 +36,31 @@
 		component_y,
 		component_z
 	};
-	JSBool toString( JSContext* cx, JSObject* obj, uintN argc, jsval* argv, jsval* rval );
-	JSBool add( JSContext* cx, JSObject* obj, uintN argc, jsval* argv, jsval* rval );
-	JSBool subtract( JSContext* cx, JSObject* obj, uintN argc, jsval* argv, jsval* rval );
-	JSBool negate( JSContext* cx, JSObject* obj, uintN argc, jsval* argv, jsval* rval );
-	JSBool scale( JSContext* cx, JSObject* obj, uintN argc, jsval* argv, jsval* rval );
-	JSBool divide( JSContext* cx, JSObject* obj, uintN argc, jsval* argv, jsval* rval );
-	JSBool dot( JSContext* cx, JSObject* obj, uintN argc, jsval* argv, jsval* rval );
-	JSBool cross( JSContext* cx, JSObject* obj, uintN argc, jsval* argv, jsval* rval );
-	JSBool length( JSContext* cx, JSObject* obj, uintN argc, jsval* argv, jsval* rval );
-	JSBool normalize( JSContext* cx, JSObject* obj, uintN argc, jsval* argv, jsval* rval );
+	JSBool toString(JSContext* cx, uintN argc, jsval* vp);
 
 	struct Vector3D_Info
 	{
 		IPropertyOwner* owner;
-		void ( IPropertyOwner::*updateFn )();
-		void ( IPropertyOwner::*freshenFn )();
+		void (IPropertyOwner::*updateFn)();
+		void (IPropertyOwner::*freshenFn)();
 		CVector3D* vector;
 		Vector3D_Info();
-		Vector3D_Info( float x, float y, float z );
-		Vector3D_Info( const CVector3D& copy );
-		Vector3D_Info( CVector3D* attach, IPropertyOwner* _owner );
-		Vector3D_Info( CVector3D* attach, IPropertyOwner* _owner, void (IPropertyOwner::*_updateFn)(void) );
-		Vector3D_Info( CVector3D* attach, IPropertyOwner* _owner, void (IPropertyOwner::*_updateFn)(void), void (IPropertyOwner::*_freshenFn)(void) );
+		Vector3D_Info(float x, float y, float z);
+		Vector3D_Info(const CVector3D& copy);
+		Vector3D_Info(CVector3D* attach, IPropertyOwner* _owner);
+		Vector3D_Info(CVector3D* attach, IPropertyOwner* _owner, void(IPropertyOwner::*_updateFn)(void));
+		Vector3D_Info(CVector3D* attach, IPropertyOwner* _owner, void(IPropertyOwner::*_updateFn)(void), void(IPropertyOwner::*_freshenFn)(void));
 		~Vector3D_Info();
 	};
 	extern JSClass JSI_class;
 	extern JSPropertySpec JSI_props[];
 	extern JSFunctionSpec JSI_methods[];
 
-	JSBool getProperty( JSContext* cx, JSObject* obj, jsval id, jsval* vp );
-    JSBool setProperty( JSContext* cx, JSObject* obj, jsval id, jsval* vp );
-	void finalize( JSContext* cx, JSObject* obj );
-	JSBool construct( JSContext* cx, JSObject* obj, uintN argc, jsval* argv, jsval* rval );
-    void init();
+	JSBool getProperty(JSContext* cx, JSObject* obj, jsid id, jsval* vp);
+	JSBool setProperty(JSContext* cx, JSObject* obj, jsid id, jsval* vp);
+	void finalize(JSContext* cx, JSObject* obj);
+	JSBool construct(JSContext* cx, uintN argc, jsval* vp);
+	void init();
 }
 
 #endif
-
-
diff -r 6b3ac7e864ba source/ps/ConfigDB.cpp
--- a/source/ps/ConfigDB.cpp	Wed Nov 03 17:52:07 2010 +0000
+++ b/source/ps/ConfigDB.cpp	Thu Nov 04 14:52:01 2010 +0000
@@ -35,34 +35,42 @@
 
 namespace ConfigNamespace_JS
 {
-	JSBool GetProperty( JSContext* cx, JSObject* obj, jsval id, jsval* vp )
+	JSBool GetProperty(JSContext* cx, JSObject* obj, jsid id, jsval* vp)
+{
+		EConfigNamespace cfgNs = GET_NS_PRIVATE(cx, obj);
+		if (cfgNs < 0 || cfgNs >= CFG_LAST)
+			return JS_FALSE;
+
+		jsval idval;
+		if (!JS_IdToValue(cx, id, &idval))
+			return JS_FALSE;
+
+		CStr propName = g_ScriptingHost.ValueToString(idval);
+		CConfigValue *val = g_ConfigDB.GetValue(cfgNs, propName);
+		if (val)
+		{
+			JSString *js_str = JS_NewStringCopyN(cx, val->m_String.c_str(), val->m_String.size());
+			*vp = STRING_TO_JSVAL(js_str);
+		}
+		return JS_TRUE;
+	}
+
+	JSBool SetProperty(JSContext* cx, JSObject* obj, jsid id, jsval* vp)
 	{
 		EConfigNamespace cfgNs = GET_NS_PRIVATE(cx, obj);
 		if (cfgNs < 0 || cfgNs >= CFG_LAST)
 			return JS_FALSE;
 
-		CStr propName = g_ScriptingHost.ValueToString(id);
-		CConfigValue *val=g_ConfigDB.GetValue(cfgNs, propName);
-		if (val)
-		{
-			JSString *js_str=JS_NewStringCopyN(cx, val->m_String.c_str(), val->m_String.size());
-			*vp = STRING_TO_JSVAL(js_str);
-		}
-		return JS_TRUE;
-	}
-
-	JSBool SetProperty( JSContext* cx, JSObject* obj, jsval id, jsval* vp )
-	{
-		EConfigNamespace cfgNs = GET_NS_PRIVATE(cx, obj);
-		if (cfgNs < 0 || cfgNs >= CFG_LAST)
+		jsval idval;
+		if (!JS_IdToValue(cx, id, &idval))
 			return JS_FALSE;
 
-		CStr propName = g_ScriptingHost.ValueToString(id);
-		CConfigValue *val=g_ConfigDB.CreateValue(cfgNs, propName);
+		CStr propName = g_ScriptingHost.ValueToString(idval);
+		CConfigValue *val = g_ConfigDB.CreateValue(cfgNs, propName);
 		char *str;
 		if (JS_ConvertArguments(cx, 1, vp, "s", &str))
 		{
-			val->m_String=str;
+			val->m_String = str;
 			return JS_TRUE;
 		}
 		else
@@ -77,13 +85,12 @@
 		JS_ConvertStub, JS_FinalizeStub
 	};
 
-	JSBool Construct( JSContext* cx, JSObject* obj, uintN argc, jsval* UNUSED(argv), jsval* rval )
+	JSBool Construct(JSContext* cx, uintN argc, jsval* vp)
 	{
-		if (argc != 0)
-			return JS_FALSE;
+		UNUSED2(argc);
 
-		JSObject *newObj=JS_NewObject(cx, &Class, NULL, obj);
-		*rval=OBJECT_TO_JSVAL(newObj);
+		JSObject *newObj = JS_NewObject(cx, &Class, NULL, NULL);
+		JS_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(newObj));
 		return JS_TRUE;
 	}
 
@@ -92,9 +99,9 @@
 		JS_SetPrivate(cx, obj, (void *)((uintptr_t)cfgNs << 1)); // JS requires bottom bit = 0
 	}
 
-	JSBool WriteFile( JSContext* cx, JSObject* obj, uintN argc, jsval* argv, jsval* rval )
+	JSBool WriteFile(JSContext* cx, uintN argc, jsval* vp)
 	{
-		EConfigNamespace cfgNs = GET_NS_PRIVATE(cx, obj);
+		EConfigNamespace cfgNs = GET_NS_PRIVATE(cx, JS_THIS_OBJECT(cx, vp));
 		if (cfgNs < 0 || cfgNs >= CFG_LAST)
 			return JS_FALSE;
 		
@@ -103,44 +110,45 @@
 
 		JSBool useVFS;
 		char *path;
-		if (JS_ConvertArguments(cx, 2, argv, "bs", &useVFS, &path))
+		if (JS_ConvertArguments(cx, argc, JS_ARGV(cx, vp), "bs", &useVFS, &path))
 		{
-			JSBool res=g_ConfigDB.WriteFile(cfgNs, useVFS?true:false, CStrW(path));
-			*rval = BOOLEAN_TO_JSVAL(res);
+			JSBool res = g_ConfigDB.WriteFile(cfgNs, useVFS ? true : false, CStrW(path));
+			JS_SET_RVAL(cx, vp, BOOLEAN_TO_JSVAL(res));
 			return JS_TRUE;
 		}
 		else
 			return JS_FALSE;
 	}
 
-	JSBool Reload( JSContext* cx, JSObject* obj, uintN argc, jsval* UNUSED(argv), jsval* rval )
+	JSBool Reload(JSContext* cx, uintN argc, jsval* vp)
 	{
 		if (argc != 0)
 			return JS_FALSE;
 
-		EConfigNamespace cfgNs = GET_NS_PRIVATE(cx, obj);
+		EConfigNamespace cfgNs = GET_NS_PRIVATE(cx, JS_THIS_OBJECT(cx, vp));
 		if (cfgNs < 0 || cfgNs >= CFG_LAST)
 			return JS_FALSE;
 
-		JSBool ret=g_ConfigDB.Reload(cfgNs);
-		*rval = BOOLEAN_TO_JSVAL(ret);
+		JSBool ret = g_ConfigDB.Reload(cfgNs);
+		JS_SET_RVAL(cx, vp, BOOLEAN_TO_JSVAL(ret));
 		return JS_TRUE;
 	}
 
-	JSBool SetFile( JSContext* cx, JSObject* obj, uintN argc, jsval* argv, jsval* UNUSED(rval) )
+	JSBool SetFile(JSContext* cx, uintN argc, jsval* vp)
 	{
 		if (argc != 0)
 			return JS_FALSE;
 
-		EConfigNamespace cfgNs = GET_NS_PRIVATE(cx, obj);
+		EConfigNamespace cfgNs = GET_NS_PRIVATE(cx, JS_THIS_OBJECT(cx, vp));
 		if (cfgNs < 0 || cfgNs >= CFG_LAST)
 			return JS_FALSE;
 
 		JSBool useVFS;
 		char *path;
-		if (JS_ConvertArguments(cx, 2, argv, "bs", &useVFS, &path))
+		if (JS_ConvertArguments(cx, argc, JS_ARGV(cx, vp), "bs", &useVFS, &path))
 		{
-			g_ConfigDB.SetConfigFile(cfgNs, useVFS?true:false, CStrW(path));
+			g_ConfigDB.SetConfigFile(cfgNs, useVFS ? true : false, CStrW(path));
+			JS_SET_RVAL(cx, vp, JSVAL_VOID);
 			return JS_TRUE;
 		}
 		else
@@ -148,9 +156,9 @@
 	}
 
 	JSFunctionSpec Funcs[] = {
-		{ "writeFile", WriteFile, 2, 0, 0},
-		{ "reload", Reload, 0, 0, 0},
-		{ "setFile", SetFile, 2, 0, 0},
+		{ "writeFile", WriteFile, 2, 0 },
+		{ "reload", Reload, 0, 0 },
+		{ "setFile", SetFile, 2, 0 },
 		{0}
 	};
 };
@@ -173,13 +181,12 @@
 		{0}
 	};
 
-	JSBool Construct( JSContext* cx, JSObject* obj, uintN argc, jsval* UNUSED(argv), jsval* rval )
+	JSBool Construct(JSContext* cx, uintN argc, jsval* vp)
 	{
-		if (argc != 0)
-			return JS_FALSE;
+		UNUSED2(argc);
 
-		JSObject *newObj=JS_NewObject(cx, &Class, NULL, obj);
-		*rval=OBJECT_TO_JSVAL(newObj);
+		JSObject *newObj = JS_NewObject(cx, &Class, NULL, NULL);
+		JS_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(newObj));
 
 		int flags=JSPROP_ENUMERATE|JSPROP_READONLY|JSPROP_PERMANENT;
 #define cfg_ns(_propname, _enum) STMT (\
@@ -204,15 +211,16 @@
 {
 	g_ScriptingHost.DefineCustomObjectType(&ConfigDB_JS::Class, ConfigDB_JS::Construct, 0, ConfigDB_JS::Props, ConfigDB_JS::Funcs, NULL, NULL);
 	g_ScriptingHost.DefineCustomObjectType(&ConfigNamespace_JS::Class, ConfigNamespace_JS::Construct, 0, NULL, ConfigNamespace_JS::Funcs, NULL, NULL);
-	JSObject *js_ConfigDB=g_ScriptingHost.CreateCustomObject("ConfigDB");
+	JSObject *js_ConfigDB = g_ScriptingHost.CreateCustomObject("ConfigDB");
 	g_ScriptingHost.SetGlobal("g_ConfigDB", OBJECT_TO_JSVAL(js_ConfigDB));
 }
 
 CConfigValue *CConfigDB::GetValue(EConfigNamespace ns, const CStr& name)
 {
-	CConfigValueSet* values = GetValues( ns, name );
-	if( !values ) return( NULL );
-	return &( (*values)[0] );
+	CConfigValueSet* values = GetValues(ns, name);
+	if (!values)
+		return (NULL);
+	return &((*values)[0]);
 }
 
 CConfigValueSet *CConfigDB::GetValues(EConfigNamespace ns, const CStr& name)
@@ -223,18 +231,18 @@
 		return NULL;
 	}
 
-	TConfigMap::iterator it = m_Map[CFG_COMMAND].find( name );
-	if( it != m_Map[CFG_COMMAND].end() )
-		return &( it->second );
+	TConfigMap::iterator it = m_Map[CFG_COMMAND].find(name);
+	if (it != m_Map[CFG_COMMAND].end())
+		return &(it->second);
 
-	for( int search_ns = ns; search_ns >= 0; search_ns-- )
+	for (int search_ns = ns; search_ns >= 0; search_ns--)
 	{
 		TConfigMap::iterator it = m_Map[search_ns].find(name);
 		if (it != m_Map[search_ns].end())
-			return &( it->second );
+			return &(it->second);
 	}
 
-	return( NULL );
+	return NULL;
 }	
 
 std::vector<std::pair<CStr, CConfigValueSet> > CConfigDB::GetValuesWithPrefix(EConfigNamespace ns, const CStr& prefix)
diff -r 6b3ac7e864ba source/ps/GameSetup/GameSetup.cpp
--- a/source/ps/GameSetup/GameSetup.cpp	Wed Nov 03 17:52:07 2010 +0000
+++ b/source/ps/GameSetup/GameSetup.cpp	Thu Nov 04 14:52:01 2010 +0000
@@ -76,9 +76,6 @@
 
 #include "maths/scripting/JSInterface_Vector3D.h"
 
-#include "graphics/scripting/JSInterface_Camera.h"
-#include "graphics/scripting/JSInterface_LightEnv.h"
-
 #include "ps/scripting/JSInterface_Console.h"
 
 #include "gui/GUI.h"
@@ -304,8 +301,6 @@
 	JSI_Vector3D::init();
 
 	// graphics
-	JSI_Camera::init();
-	JSI_LightEnv::init();
 	CGameView::ScriptingInit();
 
 	// renderer
diff -r 6b3ac7e864ba source/ps/scripting/JSInterface_Console.cpp
--- a/source/ps/scripting/JSInterface_Console.cpp	Wed Nov 03 17:52:07 2010 +0000
+++ b/source/ps/scripting/JSInterface_Console.cpp	Thu Nov 04 14:52:01 2010 +0000
@@ -1,4 +1,4 @@
-/* Copyright (C) 2009 Wildfire Games.
+/* Copyright (C) 2010 Wildfire Games.
  * This file is part of 0 A.D.
  *
  * 0 A.D. is free software: you can redistribute it and/or modify
@@ -40,81 +40,85 @@
 
 JSFunctionSpec JSI_Console::JSI_methods[] = 
 {
-	{ "write", JSI_Console::writeConsole, 1, 0, 0 },
+	{ "write", JSI_Console::writeConsole, 1, 0 },
 	{ 0 },
 };
 
-JSBool JSI_Console::getProperty( JSContext* UNUSED(cx), JSObject* UNUSED(obj), jsval id, jsval* vp )
+JSBool JSI_Console::getProperty(JSContext* UNUSED(cx), JSObject* UNUSED(obj), jsid id, jsval* vp)
 {
-	if( !JSVAL_IS_INT( id ) )
-		return( JS_TRUE );
+	if (!JSID_IS_INT(id))
+		return JS_TRUE;
 
-	int i = JSVAL_TO_INT( id );
+	int i = JSID_TO_INT(id);
 
-	switch( i )
+	switch (i)
 	{
 	case console_visible:
-		*vp = BOOLEAN_TO_JSVAL( g_Console->IsActive() ); return( JS_TRUE );
+		*vp = BOOLEAN_TO_JSVAL(g_Console->IsActive());
+		return JS_TRUE;
 	default:
-		*vp = JSVAL_NULL; return( JS_TRUE );
-	}	
+		*vp = JSVAL_NULL;
+		return JS_TRUE;
+	}
 }
 
-JSBool JSI_Console::setProperty( JSContext* UNUSED(cx), JSObject* UNUSED(obj), jsval id, jsval* vp )
+JSBool JSI_Console::setProperty(JSContext* UNUSED(cx), JSObject* UNUSED(obj), jsid id, jsval* vp)
 {
-	if( !JSVAL_IS_INT( id ) )
-		return( JS_TRUE );
+	if (!JSID_IS_INT(id))
+		return JS_TRUE;
 
-	int i = JSVAL_TO_INT( id );
+	int i = JSID_TO_INT(id);
 
-	switch( i )
+	switch (i)
 	{
 	case console_visible:
 		try
 		{
-			g_Console->SetVisible( ToPrimitive<bool>( *vp ) );
-			return( JS_TRUE );
+			g_Console->SetVisible(ToPrimitive<bool> (*vp));
+			return JS_TRUE;
 		}
-		catch( PSERROR_Scripting_ConversionFailed )
+		catch (PSERROR_Scripting_ConversionFailed )
 		{
-			return( JS_TRUE );
+			return JS_TRUE;
 		}
 	default:
-		return( JS_TRUE );
-	}	
+		return JS_TRUE;
+	}
 }
 
 void JSI_Console::init()
 {
-	g_ScriptingHost.DefineCustomObjectType( &JSI_class, NULL, 0, JSI_props, JSI_methods, NULL, NULL );
+	g_ScriptingHost.DefineCustomObjectType(&JSI_class, NULL, 0, JSI_props, JSI_methods, NULL, NULL);
 }
 
-JSBool JSI_Console::getConsole( JSContext* cx, JSObject* UNUSED(obj), jsval UNUSED(id), jsval* vp )
+JSBool JSI_Console::getConsole(JSContext* cx, JSObject* UNUSED(obj), jsid UNUSED(id), jsval* vp)
 {
-	JSObject* console = JS_NewObject( cx, &JSI_Console::JSI_class, NULL, NULL );
-	*vp = OBJECT_TO_JSVAL( console );
-	return( JS_TRUE );
+	JSObject* console = JS_NewObject(cx, &JSI_Console::JSI_class, NULL, NULL);
+	*vp = OBJECT_TO_JSVAL(console);
+	return JS_TRUE;
 }
 
-JSBool JSI_Console::writeConsole( JSContext* UNUSED(context), JSObject* UNUSED(globalObject), uintN argc, jsval* argv, jsval* UNUSED(rval) )
+JSBool JSI_Console::writeConsole(JSContext* cx, uintN argc, jsval* vp)
 {
-	debug_assert( argc >= 1 );
+	UNUSED2(cx);
+
 	CStrW output;
-	for( unsigned int i = 0; i < argc; i++ )
+	for (uintN i = 0; i < argc; i++)
 	{
 		try
 		{
-			CStrW arg = g_ScriptingHost.ValueToUCString( argv[i] );
+			CStrW arg = g_ScriptingHost.ValueToUCString(JS_ARGV(cx, vp)[i]);
 			output += arg;
 		}
-		catch( PSERROR_Scripting_ConversionFailed )
+		catch (PSERROR_Scripting_ConversionFailed )
 		{
 		}
 	}
 
 	// TODO: What if the console has been destroyed already?
 	if (g_Console)
-		g_Console->InsertMessage( L"%ls", output.c_str() );
+		g_Console->InsertMessage(L"%ls", output.c_str());
 
-	return( JS_TRUE );
+	JS_SET_RVAL(cx, vp, JSVAL_VOID);
+	return JS_TRUE;
 }
diff -r 6b3ac7e864ba source/ps/scripting/JSInterface_Console.h
--- a/source/ps/scripting/JSInterface_Console.h	Wed Nov 03 17:52:07 2010 +0000
+++ b/source/ps/scripting/JSInterface_Console.h	Thu Nov 04 14:52:01 2010 +0000
@@ -34,14 +34,14 @@
 	extern JSPropertySpec JSI_props[];
 	extern JSFunctionSpec JSI_methods[];
 
-	JSBool getProperty( JSContext* cx, JSObject* obj, jsval id, jsval* vp );
-	JSBool setProperty( JSContext* cx, JSObject* obj, jsval id, jsval* vp );
+	JSBool getProperty(JSContext* cx, JSObject* obj, jsid id, jsval* vp);
+	JSBool setProperty(JSContext* cx, JSObject* obj, jsid id, jsval* vp);
 
-	JSBool getConsole( JSContext* context, JSObject* obj, jsval id, jsval* vp );
+	JSBool getConsole(JSContext* context, JSObject* obj, jsid id, jsval* vp);
 
 	void init();
 
-	JSBool writeConsole( JSContext* context, JSObject* obj, uintN argc, jsval* argv, jsval* rval );
+	JSBool writeConsole(JSContext* cx, uintN argc, jsval* vp);
 }
 
 #endif
